@title Col.at Script Video/Foto/Zoom         Version 1
rem Autor: Herbert Eberhardt www.col.at
rem USB - Steuerung fr Canon S100
rem USB - Auslser <1 sec
rem >1sec und <4sec (ideal 2 sec) Umschalten auf Video bzw. Retour auf Foto
rem >4sec Umschalten auf Zoom
rem Foto: Auslsung
rem Video: Video ein/aus
rem Zoom: Zoomen in 5 Stufen: 0 30 60 90 120 und wieder runter 
rem  Entspricht praktisch bei  5 fach zoom S100: 24mm, 48mm, 72mm, 96mm, 120mm
rem Bildstabilisation ausschalten
rem AutoFocus AUS (auf MF)
rem Focus auf unendlich

@param v Foto = 0 Video = 1
@default v 0 

@param p MF 1
@default p 0

@param f Focus 1
@default f 0

@param g Focus 2
@default g 0

@param s Zommstufen 
@default s 8
  
@param z Zoom
@default z 0

@param x Zommen
@default x 1

@param y Zoomin=0 Zoomount=1
@default y 0

if v<0 then v=0
if v>1 then v=1

print "AF(4=manuell) ", get_prop 6
rem setzt IS auf off (Bildstabilisierung):
set_prop 145 4
rem setzt auf P-MODE:
set_capture_mode(2)
sleep 1000

get_prop 6 p
if p=1 then
  print "Manual focus (MF) found"
else
  while p<>4  
    press "left"
	sleep 3000
    release "left"
    get_prop 6 p
  wend
  print "Focus set to manual (MF)"
endif


set_quality 0
set_focus 60000
print "set_focus 65530"
sleep 2000

set_focus 100
print "set_focus 100"
sleep 2000
f=get_focus

set_focus 65530
print "set_focus 65530"
sleep 2000
g=get_focus

set_aflock 1
print "aflock 1" 
if f=g then gosub "nichtMF"

print "AF(4=manuell) ", get_prop 6

s=get_zoom_steps
print "Zoom steps=", s
z=get_zoom
if s<9 then x=1
if s>8 and s<15 then x=2
if s>14 then x=s/4
print "Zoom step=", x
if z<2 then y=0

while 1
   do
      a = get_usb_power
   until a>0
   if a < 100 then gosub "ausl" 
   if a > 99 and a < 400 then gosub "videofoto" 
   if a > 399 and a < 1000 then gosub "zoom" 
   if a > 999 then print "error"
wend
end

:ausl
   if v = 0 then gosub "takephoto" else if v = 1 then gosub "startstopvideo" else gosub "zoomen"
   return
   
:takephoto
   print "Foto!"
   shoot 
   return

:startstopvideo
   print "Start/Stop Video"
   click "video"
   return

:zoomen
   if y=0 then gosub "zoomin" else gosub "zoomout"
   return
   
:videofoto
   if v=0 then gosub "video" else gosub "foto"
   return

:video
   print "Video active"
   v=1
   return

:foto
   print "Foto active"
   v=0
   return
   
:zoom
   print "Zoomen active"
   v=3
   return
      
:zoomin
   z=z+x
   print "Zoom ",z
   set_zoom z
   if (z+x)>=s then y=1
   return
   
:zoomout
   z=z-x
   print "Zoom ",z
   set_zoom z
   if (z-x)<0 then y=0
   return
   
:nichtMF
   print "Focus NICHT AUF MANUELL"
   sleep 3000
   return